var timer = null;
var settings = [
	0,0,0,1,
	0,0,0,0,
	0,0,0,1,
	1,0,0,0,
	180,
	50,95,30,135,
	10,150,5,150,];
var req;

if(window.widget) {
	widget.onshow = startWidget;
	widget.onhide = stopWidget;
}

function startWidget(){
	if (timer == null) {
		drawClock();
		drawGuide();
	}
	checkTime();
	timer = setInterval("checkTime();", 1000);
}

function stopWidget(){
	clearClock();
	if(timer != null){
		clearInterval(timer);
		timer = null;
	}
}

function setTime(){
	myD = new Date();
	myyear = myD.getYear();
	myyear4 = (myyear < 2000) ? myyear+1900 : myyear;
	mymonth = myD.getMonth() + 1;
	mydate = myD.getDate();
	myday = myD.getDay();
	myhours = myD.getHours();
	myminutes = myD.getMinutes();
	myseconds = myD.getSeconds();
	myTbl = new Array("Sun","Mon","Tue","Wed","Thu","Fri","Sat");
}
function clearClock(){
	var canvas = document.getElementById("mainCanvas");
	var context = canvas.getContext("2d");
	context.clearRect(0,0,300,300);
	var canvas = document.getElementById("guideCanvas");
	var context = canvas.getContext("2d");
	context.clearRect(0,0,300,300);
}
function drawClock() {
	setTime();
	var canvas = document.getElementById("mainCanvas");
	var context = canvas.getContext("2d");
	var myhourspi = Math.PI*myhours/6+Math.PI*myminutes/360;
	var myminutespi = Math.PI/180*myminutes*6;
	context.clearRect(0,0,300,300);
	context.save();
	
	for(var i= 0; i < settings[16]; i++){
		context.arc(150,150,settings[18],2*Math.PI*i/settings[16]-Math.PI/2+myhourspi,2*Math.PI*(i+3)/settings[16]-Math.PI/2+myhourspi,0);
		context.lineWidth = settings[17];
		context.setStrokeColor((settings[4]-settings[0])*i/settings[16]+settings[0],(settings[5]-settings[1])*i/settings[16]+settings[1],(settings[6]-settings[2])*i/settings[16]+settings[2],(settings[7]-settings[3])*i/settings[16]+settings[3]);
		context.stroke();
	}
	context.restore();
	context.save();
	for(var i= 0; i < settings[16]; i++){
		context.arc(150,150,settings[20],2*Math.PI*i/settings[16]-Math.PI/2+myminutespi,2*Math.PI*(i+3)/settings[16]-Math.PI/2+myminutespi,0);
		context.lineWidth = settings[19];
		context.setStrokeColor((settings[12]-settings[8])*i/settings[16]+settings[8],(settings[13]-settings[9])*i/settings[16]+settings[9],(settings[14]-settings[10])*i/settings[16]+settings[10],(settings[15]-settings[11])*i/settings[16]+settings[11]);
		context.stroke();
	}
	context.restore();
//	document.getElementById("timeStrings").innerHTML = mymonth+"/"+mydate+" ("+myTbl[myday]+") "+myhours+":"+myminutes;
}

function drawGuide() {
	var canvas = document.getElementById("guideCanvas");
	var context = canvas.getContext("2d");
	var hourguide = 12
	context.save();
	for(var i= 0; i < hourguide; i++){
		context.save();
		context.translate(150,150);
		context.rotate(i*(2*Math.PI/hourguide));
		context.beginPath();
		context.moveTo(settings[22],0);
		context.lineTo(settings[22]-settings[21],0);
		context.lineWidth = 1;
		context.strokeStyle = "rgba(255,255,255,1)";
		context.closePath();
		context.stroke();
		context.restore();
	}
	context.restore();
	context.save();
	var minguide =60
	for(var i= 0; i < minguide; i++){
		context.save();
		context.translate(150,150);
		context.rotate(i*(2*Math.PI/minguide));
		context.beginPath();
		context.moveTo(settings[24],0);
		context.lineTo(settings[24]-settings[23],0);
		context.lineWidth = 0.5;
		context.strokeStyle = "rgba(255,255,255,1)";
		context.closePath();
		context.stroke();
		context.restore();
	}
	context.restore();
}

function checkTime() {
	if(timer != null){
		myD = new Date();
		myseconds = myD.getSeconds();
		if (myseconds == "00") {
			drawClock()
		}
	}
}

/*//////////////////////////////////////////////////////
//infoButton////////////////////////////////////////////
//////////////////////////////////////////////////////*/

function startUp(){
	var infoRollie = document.getElementById("infoRollie");
	var front = document.getElementById("front");
	var info = document.getElementById("info");
	var done = document.getElementById("done");
	createInfoButton(front, info, "white");
	createInfoRollieButton(infoRollie, "white");
	createGenericButton(done, "Done", showFrontSide);
	loadSetting(readyLoadSettingName);
}
var infoBody = null;
var infoButton = null;
var infoRollieButton = null;

function createInfoButton(body, div, color){
	var backgroundUrl = "file:///System/Library/WidgetResources/iButton/" + color + "_i.png";
	div.setAttribute("style", "opacity: 0.0; background:url(" + backgroundUrl + ") no-repeat top left;");
	body.addEventListener("mouseover", infoBodyMouseOver, true);
	body.addEventListener("mouseout", infoBodyMouseOut, true);
	infoBody = body;
	infoButton = div;
}
function infoBodyMouseOver(event){
	infoButtonStartAnimationInDirection(1);
}
function infoBodyMouseOut(event){
	infoButtonStartAnimationInDirection(0);
}
function createInfoRollieButton(div,color){
	var backgroundUrl = "file:///System/Library/WidgetResources/iButton/" + color + "_rollie.png";
	div.setAttribute("style", "opacity: 0.0; background: url(" + backgroundUrl + ") no-repeat top left;");
	div.addEventListener("mouseover", infoRollieButtonMouseOver, true);
	div.addEventListener("mouseout", infoRollieButtonMouseOut, true);
	infoRollieButton = div;
}
function infoRollieButtonMouseOver(event){
	infoRollieButton.style.opacity = "0.25";
}
function infoRollieButtonMouseOut(event){
	infoRollieButton.style.opacity = "0.0";
}
var infoAnimator = {
	fromValue: 0.0,
	toValue: 1.0,
	currentValue: 0.0,
	duration: 500,
	direction: 0,
	startTime: 0,
	frameRate: 13,
	timer: null
};
function infoButtonStartAnimationInDirection(direction){
	if (direction !=infoAnimator.direction){
		infoButtonStopAnimate();
		infoAnimator.startTime = (new Date).getTime() - infoAnimator.frameRate;
		infoAnimator.fromValue = infoAnimator.currentValue;
		direction == 0 ? infoAnimator.toValue = 0.0 : infoAnimator.toValue = 1.0;
		infoAnimator.direction = direction;
		infoAnimator.timer = setInterval("infoButtonStepNextFrame();",infoAnimator.frameRate);
	}
}
function infoButtonStopAnimate(){
	if (infoAnimator.timer){
		clearInterval(infoAnimator.timer);
		infoAnimator.timer = null;
	}
}
function infoButtonStepNextFrame(){
	var elapsed = (new Date).getTime() - infoAnimator.startTime;
	if (elapsed < 0) elapsed = 0;
	if (elapsed > infoAnimator.duration) elapsed = infoAnimator.duration;
	if (elapsed >= infoAnimator.duration){
		infoButtonStopAnimate();
		infoAnimator.currentValue = infoAnimator.toValue;
	}
	else {
		var scale = 0.5 - (0.5 * Math.cos(Math.PI * elapsed / infoAnimator.duration));
		infoAnimator.currentValue = infoButtonComputeNextFloat(infoAnimator.fromValue,infoAnimator.toValue,scale);
		}
	infoButton.style.opacity = infoAnimator.currentValue;
}
function infoButtonComputeNextFloat(from,to,ease){
	return from + (to - from) * ease;
}

function showBackSide(event){
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	if (window.widget) widget.prepareForTransition("ToBack");
	front.style.display = "none";
	back.style.display = "block";
	if (window.widget) setTimeout("widget.performTransition();", 0);
	var infoRollie = document.getElementById("infoRollie");
	infoRollie.style.opacity = "0.0";
	stopWidget();
}
function showFrontSide(event){
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	if (window.widget) widget.prepareForTransition("ToFront");
	front.style.display = "block";
	back.style.display = "front";
	if (window.widget) setTimeout("widget.performTransition();", 0);
	startWidget();
}

////////////////////////////////////////////////////////
////////////////////////////////////////////////////////
////////////////////////////////////////////////////////

function loadSetting(event) {
	req = new XMLHttpRequest();
	req.onreadystatechange = event;
	req.overrideMimeType("text/xml");
	req.open("GET", "./setting.xml");
	req.send(null);
}
function readyStateChange(){
	if (req.readyState == 4) {
		if (req.responseXML){
			var settingnumber = document.getElementById("setting").value;
			var xmldata = req.responseXML.getElementsByTagName("item");

			settings[0] = xmldata[settingnumber].getElementsByTagName("hourbeforered")[0].firstChild.nodeValue;
			settings[1] = xmldata[settingnumber].getElementsByTagName("hourbeforegreen")[0].firstChild.nodeValue;
			settings[2] = xmldata[settingnumber].getElementsByTagName("hourbeforeblue")[0].firstChild.nodeValue;
			settings[3] = xmldata[settingnumber].getElementsByTagName("hourbeforetransparency")[0].firstChild.nodeValue;
			
			settings[4] = xmldata[settingnumber].getElementsByTagName("houraftered")[0].firstChild.nodeValue;
			settings[5] = xmldata[settingnumber].getElementsByTagName("houraftergreen")[0].firstChild.nodeValue;
			settings[6] = xmldata[settingnumber].getElementsByTagName("hourafterblue")[0].firstChild.nodeValue;
			settings[7] = xmldata[settingnumber].getElementsByTagName("houraftertransparency")[0].firstChild.nodeValue;
			
			settings[8] = xmldata[settingnumber].getElementsByTagName("minutebeforered")[0].firstChild.nodeValue;
			settings[9] = xmldata[settingnumber].getElementsByTagName("minutebeforegreen")[0].firstChild.nodeValue;
			settings[10] = xmldata[settingnumber].getElementsByTagName("minutebeforeblue")[0].firstChild.nodeValue;
			settings[11] = xmldata[settingnumber].getElementsByTagName("minutebeforetransparency")[0].firstChild.nodeValue;
			
			settings[12] = xmldata[settingnumber].getElementsByTagName("minuteaftered")[0].firstChild.nodeValue;
			settings[13] = xmldata[settingnumber].getElementsByTagName("minuteaftergreen")[0].firstChild.nodeValue;
			settings[14] = xmldata[settingnumber].getElementsByTagName("minuteafterblue")[0].firstChild.nodeValue;
			settings[15] = xmldata[settingnumber].getElementsByTagName("minuteaftertransparency")[0].firstChild.nodeValue;
			
			settings[16] = xmldata[settingnumber].getElementsByTagName("gradation")[0].firstChild.nodeValue;
			
			settings[17] = xmldata[settingnumber].getElementsByTagName("hourhandwidth")[0].firstChild.nodeValue;
			settings[18] = xmldata[settingnumber].getElementsByTagName("hourradius")[0].firstChild.nodeValue;
			settings[19] = xmldata[settingnumber].getElementsByTagName("minutehandwidth")[0].firstChild.nodeValue;
			settings[20] = xmldata[settingnumber].getElementsByTagName("minuteradius")[0].firstChild.nodeValue;
			
			settings[21] = xmldata[settingnumber].getElementsByTagName("hourhandguideheight")[0].firstChild.nodeValue;
			settings[22] = xmldata[settingnumber].getElementsByTagName("hourhandguideradius")[0].firstChild.nodeValue;
			settings[23] = xmldata[settingnumber].getElementsByTagName("minutehandguideheight")[0].firstChild.nodeValue;
			settings[24] = xmldata[settingnumber].getElementsByTagName("minutehandguideradius")[0].firstChild.nodeValue;
		for(i in settings)
			document.getElementById("debug").innerHTML += settings[i] + "<BR>";
		}
	}
}
function readyLoadSettingName(){
	if (req.readyState == 4) {
		if (req.responseXML){
			var xmldata = req.responseXML.getElementsByTagName("name");
			var titlelength = xmldata.length;
			for (i=0; i<titlelength; i++){
				document.getElementById("setting").innerHTML += "<option value=" + i + ">" + xmldata[i].firstChild.nodeValue + "</option>";
			}
		}
	}
}